<?php

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

class modCirleLinkCatByMatItemList {
	var $id;
	var $title;
	var $link;
	var $access;
	var $alias;
	var $afterCircle;
	var $introtext;
	var $catid;
}

class modCirleLinkCatByMat {

	const ACCESS_ALL                 = 1;
	const ACCESS_REGISTERED          = 2;
	const ACCESS_SPECIAL	         = 3;
	
	public function getSection($iId) {
		$database = &JFactory::getDBO();
		if(JRequest::getVar( 'view', 'NONE') == "frontpage"){
			return 1;
		}else if(JRequest::getVar( 'view', 'NONE') == "section"){
			return JRequest::getVar( 'id', 'NONE');
		}else if(JRequest::getVar( 'view', 'NONE') == "category"){
			//echo 'hit category';
			$sql = "SELECT section as catid FROM #__categories WHERE id = ".$iId;
			$database->setQuery( $sql );
			$row = $database->loadResult();
			return $row;
		}else if(JRequest::getVar( 'view', 'NONE') == "article"){
			//echo 'hit article';
			$sql = "SELECT catid FROM #__content WHERE id = ".$iId;
			$database->setQuery( $sql );
			$row = $database->loadResult();
			return $row;
		}
	}
   
	// Сохраняем копию записи - особенность работы адептера MySql
	function cloneRecord($row) {
		$item = new modCirleLinkCatByMatItemList();
		
		$item->id = $row->id;
		$item->title = $row->title;
		$item->link = $row->link;
		$item->access = $row->access;
		$item->alias = $row->alias;
		$item->afterCircle = $row->afterCircle;
		$item->introtext = $row->introtext;
		$item->catid = $row->catid;
		
		return $item;
	}
   
	// Простое получение доступа
	function getAccess($item) {
		return $item->access; 
	}

	// Проверка доступа
	function isAccessible(&$item, &$user) {
		if ($user->guest) {
			if ($this->getAccess($item) == $this::ACCESS_ALL) return true;
		} else {
			if ($this->getAccess($item) >= $this::ACCESS_ALL) return true;
		}
		return false;
	}

	// Это статья?
	function isArticle() {
		return JRequest::getVar( 'view', 'NONE') == "article";
	}
	
	// Это категория?
	function isCategory () {
		return JRequest::getVar( 'view', 'NONE') == "category";
	}
	
	// Если материал уже есть (в случае малого списка статье в категории)
	function haveInList(& $list, $id) {
		$countList = count($list);

		for ($i = 0; $i < $countList; $i++)
			if($list[$i]->id == $id)
				return true;
		
		return false;
	}
	
	// Если необходимо, то формируем фильтр для исключенных категорий
	function getExceptWhereForCatSearch($startPart, $exceptCat) {
		if(is_array($exceptCat) && count($exceptCat) > 0) {
			$result = $startPart.' (';
			$exceptCatCount = count($exceptCat);
			
			for($i = 0; $i < $exceptCatCount; $i++) {
				$result .= $exceptCat[$i];
				if ($i + 1 != $exceptCatCount) 
					$result .= ', ';
			}			
			
			return $result.') ';
		}
		return '';
	}
	
	// Формируем условие по доступу в зависимости от доступа пользователя
	function getAccessWhereForUser($startPart, &$user) {
		if ($user->guest) {
			return $startPart.' = '.($this::ACCESS_ALL).' ';
		}
		else {
			return $startPart.' >= '.($this::ACCESS_ALL).' ';
		}
	}
	
	// Формируем условие для выборки id статей
	function getMaterialWhereForModule($startPart, $materialNumber, $linksCount, $shiftCount, $maxCount) {
		if ($maxCount == 0) return '';
		$result = ' (';
		$findElements = array();
		$matRownum = 0;
		$shift = 0;
		
		// Если сдвиг больше количества материалов, то ограничиваем его
		if ($shiftCount >= $maxCount) $shift = $maxCount == 1 ? 1 : $maxCount - 1;
		// иначе просто запоминаем сдвиг
		else $shift = $shiftCount;

		// Определяем стартовую позицию
		$matRownum = ($shift + $materialNumber) % $maxCount;
		if ($matRownum == 0) $matRownum = $maxCount;
		
		// Проходимся по кольцу ровно столько раз, сколько нужно ссылок
		for($i = 0; $i < $linksCount; $i++) {
			if (!in_array($matRownum, $findElements)) {
				$findElements[] = $matRownum;
			}
			// Сдвигаем элемент
			$matRownum = ($matRownum + $shift) % $maxCount;
			if ($matRownum == 0) $matRownum = $maxCount;
		}
		
		// Если нашлось меньше ссылок, чем нужно, но элементы все еще есть,
		// то просто добавляем ближайшие элементы к материалу
		if (count($findElements) < $linksCount && count($findElements) < $maxCount) {
			$addingCounter = ($materialNumber + 1) % $maxCount;
			if ($addingCounter == 0) $addingCounter = $maxCount;
			// Заполняем набор пока либо не найдем нужное количество ссылок, либо не закончится набор доступных ссылок
			while(count($findElements) < $linksCount && count($findElements) < $maxCount) {
				// Если элемента нет в массиве, то добавляем его
				if (!in_array($addingCounter, $findElements)) {
					$findElements[] = $addingCounter;
				}
				// Сдвигаем элемент
				$addingCounter = ($addingCounter + 1) % $maxCount;
				if ($addingCounter == 0) $addingCounter = $maxCount;
			}
		}
		
		// Формируем набор
		for($i = 0; $i < count($findElements); $i++) {
			$result .= $findElements[$i];
			if ($i + 1 != count($findElements))
				$result .= ', ';
		}
		
		return $startPart.$result.') ';
	}
	
	// Получение списка элементов
	public function getList($idMat, $idCat, $linksCount, $shiftCount, $orderCat, $exceptCat) {
		$showList = array();

		$user = JFactory::getUser();
		$db = & JFactory::getDBO();
		$menu = &JSite::getMenu();
		$idCurMat = 0;
		$nextCatID = null;
		$curMatPosition = 0;
		$queryGetNextCat = '';

		// Получаем элементы номер следующей категории, если таковое возможно
		if (($this->isArticle() || $this->isCategory()) 
			&& ($menu->getActive()!= $menu->getDefault())) {
			// Получаем следующую категорию
			// Если указан порядок для элемента
			if (!empty($orderCat) && is_array($orderCat) && in_array($idCat, $orderCat) && array_search($idCat, $orderCat) < count($orderCat) - 1) {
				$nextCatID = $orderCat[array_search($idCat, $orderCat) + 1];
			}
			// Иначе ищем следующую категорию с учетом кольца
			else {
				$queryGetNextCat = '
					select a.id
					from (
						select distinct cat.id, 0 as afterCircle
						from #__categories cat
							join #__content mat
								on cat.id = mat.catid
									and mat.state > 0
									and ( 
										mat.publish_down is null 
										or mat.publish_down >= NOW()
									)
									and ( 
										mat.publish_up is null 
										or mat.publish_up < NOW()
									)
									and cat.published > 0
						where cat.id > '.$idCat.'
							'.$this->getExceptWhereForCatSearch(' and cat.id not in ', $exceptCat).'
							'.$this->getAccessWhereForUser(' and mat.access ', $user).'
							'.$this->getAccessWhereForUser(' and cat.access ', $user).'
						union
						select distinct cat.id, 1 as afterCircle
						from #__categories cat
							join #__content mat
								on cat.id = mat.catid
									and mat.state > 0
									and ( 
										mat.publish_down is null 
										or mat.publish_down >= NOW()
									)
									and ( 
										mat.publish_up is null 
										or mat.publish_up < NOW()
									)
									and cat.published > 0
						where cat.id < '.$idCat.'
							'.$this->getExceptWhereForCatSearch(' and cat.id not in ', $exceptCat).'
							'.$this->getAccessWhereForUser(' and mat.access ', $user).'
							'.$this->getAccessWhereForUser(' and cat.access ', $user).'
					) a
					order by a.afterCircle asc, id asc
					limit 1
				';
				$db->setQuery($queryGetNextCat);
				$nextCatID = $db->loadResult();
			}
		}
		
		$queryGetMaterials = '';
		// Если на странице отображена статья и есть соседняя категория,
		if ($this->isArticle() && !empty($nextCatID)) {
			// Получаем номер элемента в списке
			$db->setQuery('
				select rownum
				from (
					select *,
						@rownum:= @rownum + 1 as rownum
					from #__content mat, (select @rownum:=0) a
					where mat.state > 0
					and ( 
						mat.publish_down is null 
						or mat.publish_down >= NOW()
					)
					and ( 
						mat.publish_up is null 
						or mat.publish_up < NOW()
					)
					'.$this->getAccessWhereForUser(' and mat.access ', $user).'
					and mat.catid = '.$idCat.'
					order by mat.created
				) a
				where id = '.$idMat.'
			');
			
			
			$materialNumber = $db->loadResult();
			
			// Получаем количество статей в нужной категории
			// Получаем номер элемента в списке
			$db->setQuery('
				select count(*)
				from #__content mat
				where mat.state > 0
				and ( 
					mat.publish_down is null 
					or mat.publish_down >= NOW()
				)
				and ( 
					mat.publish_up is null 
					or mat.publish_up < NOW()
				)
				'.$this->getAccessWhereForUser(' and mat.access ', $user).'
				and mat.catid = '.$nextCatID.'
			');
			
			$maxCount = $db->loadResult();
			
			// Формируем итоговый запрос
			$queryGetMaterials = '
				select id, catid, \'\' as link, title, access, alias, introtext
				from (
					select *,
						@rownum:= @rownum + 1 as rownum
					from #__content mat, (select @rownum := 0) a
					where mat.state > 0
					and ( 
						mat.publish_down is null 
						or mat.publish_down >= NOW()
					)
					and ( 
						mat.publish_up is null 
						or mat.publish_up < NOW()
					)
					'.$this->getAccessWhereForUser(' and mat.access ', $user).'
					and mat.catid = '.$nextCatID.'
					order by mat.created
				) a
				where '.$this->getMaterialWhereForModule(' a.rownum in ', $materialNumber, $linksCount, $shiftCount, $maxCount).'
			';
			
		}
		// Если на странице отображена категория и есть соседняя категория,
		// то берем случайные статьи из следующей категории
		else if ($this->isCategory() && !empty($nextCatID)) {
			$queryGetMaterials = '
				select id, catid, \'\' as link, title, access, alias, introtext
				from #__content mat
				where mat.state > 0
					and ( 
						mat.publish_down is null 
						or mat.publish_down >= NOW()
					)
					and ( 
						mat.publish_up is null 
						or mat.publish_up < NOW()
					)
					'.$this->getExceptWhereForCatSearch(' and mat.catid not in ', $exceptCat).'
					and mat.catid = '.$nextCatID.'
					'.$this->getAccessWhereForUser(' and mat.access ', $user).'
				order by rand()
				limit '.$linksCount.'
			';
		}
		// Иначе формируем случайный вывод статей из всех доступных категорий
		else {
			$queryGetMaterials = '
				select id, catid, \'\' as link, title, access, alias, introtext
				from #__content mat
				where mat.state > 0
					and ( 
						mat.publish_down is null 
						or mat.publish_down >= NOW()
					)
					and ( 
						mat.publish_up is null 
						or mat.publish_up < NOW()
					)
					'.$this->getExceptWhereForCatSearch(' and mat.catid not in ', $exceptCat).'
					'.$this->getAccessWhereForUser(' and mat.access ', $user).'
				order by rand()
				limit '.$linksCount.'
			';
		}

		$db->setQuery($queryGetMaterials);
		$showList = $db->loadObjectList();
		
		// Для всех полученных элементов добавляем link
		if(count($showList) > 0) {
			$countShowList = count ($showList);
			for ($i = 0; $i < $countShowList; $i++) {
				$itemid = &JSite::getMenu()->getItems('link', 'index.php?option=com_content&view=article&id='.($showList[$i]->id), true);
				if(!empty($itemid)) {
					$showList[$i]->link = JRoute::_('index.php?Itemid='.$itemid->id);
				}
				else {
					$catitemid = JSite::getMenu()->getItems('link', 'index.php?option=com_content&view=category&id='.$showList[$i]->catid, true);
					if(!empty($catitemid)) {
						$showList[$i]->link = JRoute::_('index.php?option=com_content&view=article&id='.($showList[$i]->id).':'.($showList[$i]->alias).'&catid='.$showList[$i]->catid.'&Itemid='.$catitemid->id);
					}
					else
						$showList[$i]->link = JRoute::_('index.php?option=com_content&view=article&id='.($showList[$i]->id).':'.($showList[$i]->alias).'&catid='.$showList[$i]->catid);
				}
			}
		}
		
		return $showList;
	}
}

?>

